#include <windows.h>
#include "filter.h"
#include <emmintrin.h>
#include <math.h>

#define MAX_RADIUS 4
#define TRACK_N    2                     //    gbNo[̐
TCHAR*  track_name[] = {"͈", "U"}; //    gbNo[̖O
int     track_default[] ={1, 40};        //    gbNo[̏l
int     track_s[] = {1, 1};              //    gbNo[̉l
int     track_e[] = {MAX_RADIUS, 100};   //    gbNo[̏l
#define CHECK_N 1
TCHAR*  check_name[] = {"KEVAd"};
int     check_default[] = {1};

FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION, //    tB^̃tO
    0,0,                        //    ݒEChẼTCY (FILTER_FLAG_WINDOW_SIZEĂ鎞ɗL)
#ifdef _HT_
    "NL-Means Light(HT)",       //    tB^̖O
#else
    "NL-Means Light",
#endif
    TRACK_N,                    //    gbNo[̐ (0Ȃ疼OlNULLł悢)
    track_name,                 //    gbNo[̖OSւ̃|C^
    track_default,              //    gbNo[̏lSւ̃|C^
    track_s,track_e,            //    gbNo[̐l̉ (NULLȂS0`256)
    CHECK_N,                    //    `FbN{bNX̐ (0Ȃ疼OlNULLł悢)
    check_name,                 //    `FbN{bNX̖OSւ̃|C^
    check_default,              //    `FbN{bNX̏lSւ̃|C^
    func_proc,                  //    tB^֐ւ̃|C^ (NULLȂĂ΂܂)
    func_init,                  //    JnɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    func_exit,                  //    IɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    func_update,                //    ݒ肪ύXꂽƂɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,                       //    ݒEBhEɃEBhEbZ[WɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,NULL,                  //    VXeŎg܂̂ŎgpȂł
    NULL,                       //  gf[^̈ւ̃|C^ (FILTER_FLAG_EX_DATAĂ鎞ɗL)
    NULL,                       //  gf[^TCY (FILTER_FLAG_EX_DATAĂ鎞ɗL)
#ifdef _HT_
    "NL-Means Light(HT) ver.111113",//  tB^ւ̃|C^ (FILTER_FLAG_EX_INFORMATIONĂ鎞ɗL)
#else
    "NL-Means Light ver.111113",
#endif
    NULL,                       //    Z[uJn钼OɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
    NULL,                       //    Z[uIOɌĂ΂֐ւ̃|C^ (NULLȂĂ΂܂)
};

#define M_LN2      0.693147180559945309417

__m128 f128_fastexp2_a;
__m128 f128_fastexp2_bmc;
__m128 f128_fastexp2_min;
__m128 f128_gw1;
__m128 f128_gw2;
__m128 f128_1;

int v_blocksize;
int worksize;

typedef struct {
    FILTER              *fp;
    FILTER_PROC_INFO    *fpip;
    int                 maxblock;
    int                 xblocks;
    int                 atomic_counter;
    BYTE*               ycp_edit;
    BYTE*               work;
    BYTE*               ycp_temp;
    BYTE*               temp;
    int                 src_bpl;
    int                 temp_bpl;
    int                 span;
    int                 pitch;
    int                 width;
    int                 height;
    int                 radius;
} FILTER_PARAM;

//LUMABUF_BPL = (((H_BLOCKSIZE / 4)+ (MAX_RADIUS + 1) * 2) * (sizeof(float) * 4) + 63) &~63;
//WEIGHTBUF_BPL = (((H_BLOCKSIZE / 4)+ MAX_RADIUS * 2) * ((sizeof(float) * 4) * 3) + 63) &~63;

#ifdef _HT_
#define H_BLOCKSIZE 160
#define LUMABUF_BPL 832
#define WEIGHTBUF_BPL 2304
#else
#define H_BLOCKSIZE 320
#define LUMABUF_BPL 1472
#define WEIGHTBUF_BPL 4224
#endif

#define DIFFBUF_BPL (((H_BLOCKSIZE / 4 + 2) * 32 + 127) &~127)

//---------------------------------------------------------------------
//        tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    return &filter;
}

static __forceinline void fill_line_left(BYTE* src, BYTE* dest, int pitch, int xloop, int xloop2)
{
    BYTE* src2 = src + xloop*6;
    __asm
    {
        push            edi
        push            esi
        mov             esi, src2
        mov             edi, dest
        pinsrw          xmm2, [esi], 1
        mov             eax, pitch
        mov             esi, src
        lea             edx, [eax+eax*2]
        mov             ecx, xloop
    align 16
    loop1:
        movdqa          xmm0, xmm2
        pinsrw          xmm0, [esi+eax  ], 3
        pinsrw          xmm0, [esi+eax*2], 5
        pinsrw          xmm0, [esi+edx  ], 7
        psrad           xmm0, 16
        cvtdq2ps        xmm1, xmm0
        movaps          [edi], xmm1
        add             esi, 6
        add             edi, 16
        sub             ecx, 1
        jnz             loop1
        
        mov             ecx, xloop2
        sub             ecx, 1
    align 16
    loop2:
        pxor            xmm0, xmm0
        pxor            xmm1, xmm1
        pinsrw          xmm0, [esi        ], 1
        pinsrw          xmm1, [esi      +6], 1
        pinsrw          xmm0, [esi+eax    ], 3
        pinsrw          xmm1, [esi+eax  +6], 3
        pinsrw          xmm0, [esi+eax*2  ], 5
        pinsrw          xmm1, [esi+eax*2+6], 5
        pinsrw          xmm0, [esi+edx    ], 7
        pinsrw          xmm1, [esi+edx  +6], 7
        psrad           xmm0, 16
        psrad           xmm1, 16
        cvtdq2ps        xmm2, xmm0
        cvtdq2ps        xmm3, xmm1
        movaps          [edi], xmm2
        movaps          [edi+16], xmm3
        add             esi, 12
        add             edi, 32
        sub             ecx, 2
        jnle            loop2
        add             ecx, 1
        jz              loop2end
        
        pinsrw          xmm0, [esi      ], 1
        pinsrw          xmm0, [esi+eax  ], 3
        pinsrw          xmm0, [esi+eax*2], 5
        pinsrw          xmm0, [esi+edx  ], 7
        psrad           xmm0, 16
        cvtdq2ps        xmm1, xmm0
        movaps          [edi], xmm1
    loop2end:
        pop             esi
        pop             edi
    }
}

static __forceinline void fill_line_center(BYTE* src, BYTE* dest, int pitch, int xloop)
{
    __asm
    {
        push            edi
        push            esi
        mov             edi, dest
        mov             eax, pitch
        mov             esi, src
        mov             ecx, xloop
        lea             edx, [eax+eax*2]
        sub             ecx, 1
    align 16
    loop2:
        pxor            xmm0, xmm0
        pxor            xmm1, xmm1
        pinsrw          xmm0, [esi        ], 1
        pinsrw          xmm1, [esi      +6], 1
        pinsrw          xmm0, [esi+eax    ], 3
        pinsrw          xmm1, [esi+eax  +6], 3
        pinsrw          xmm0, [esi+eax*2  ], 5
        pinsrw          xmm1, [esi+eax*2+6], 5
        pinsrw          xmm0, [esi+edx    ], 7
        pinsrw          xmm1, [esi+edx  +6], 7
        psrad           xmm0, 16
        psrad           xmm1, 16
        cvtdq2ps        xmm2, xmm0
        cvtdq2ps        xmm3, xmm1
        movaps          [edi], xmm2
        movaps          [edi+16], xmm3
        add             esi, 12
        add             edi, 32
        sub             ecx, 2
        jnle            loop2
        add             ecx, 1
        jz              loop2end
        
        pinsrw          xmm0, [esi      ], 1
        pinsrw          xmm0, [esi+eax  ], 3
        pinsrw          xmm0, [esi+eax*2], 5
        pinsrw          xmm0, [esi+edx  ], 7
        psrad           xmm0, 16
        cvtdq2ps        xmm1, xmm0
        movaps          [edi], xmm1
    loop2end:
        pop             esi
        pop             edi
    }
}

static __forceinline void fill_line_right(BYTE* src, BYTE* dest, int pitch, int xloop, int xloop2)
{
    __asm
    {
        push            edi
        push            esi
        mov             edi, dest
        mov             eax, pitch
        mov             esi, src
        mov             ecx, xloop
        lea             edx, [eax+eax*2]
        sub             ecx, 1
    align 16
    loop1:
        pxor            xmm0, xmm0
        pxor            xmm1, xmm1
        pinsrw          xmm0, [esi        ], 1
        pinsrw          xmm1, [esi      +6], 1
        pinsrw          xmm0, [esi+eax    ], 3
        pinsrw          xmm1, [esi+eax  +6], 3
        pinsrw          xmm0, [esi+eax*2  ], 5
        pinsrw          xmm1, [esi+eax*2+6], 5
        pinsrw          xmm0, [esi+edx    ], 7
        pinsrw          xmm1, [esi+edx  +6], 7
        psrad           xmm0, 16
        psrad           xmm1, 16
        cvtdq2ps        xmm2, xmm0
        cvtdq2ps        xmm3, xmm1
        movaps          [edi], xmm2
        movaps          [edi+16], xmm3
        add             esi, 12
        add             edi, 32
        sub             ecx, 2
        jnle            loop1
        add             ecx, 1
        jz              loop1end
        
        pinsrw          xmm0, [esi      ], 1
        pinsrw          xmm0, [esi+eax  ], 3
        pinsrw          xmm0, [esi+eax*2], 5
        pinsrw          xmm0, [esi+edx  ], 7
        psrad           xmm0, 16
        cvtdq2ps        xmm1, xmm0
        movaps          [edi], xmm1
        add             esi, 6
        add             edi, 16
    
    loop1end:
        pinsrw          xmm2, [esi+edx-6], 7
        mov             ecx, xloop2
    align 16
    loop2:
        movaps          xmm0, xmm2
        pinsrw          xmm0, [esi      ], 1
        pinsrw          xmm0, [esi+eax  ], 3
        pinsrw          xmm0, [esi+eax*2], 5
        psrad           xmm0, 16
        cvtdq2ps        xmm1, xmm0
        movaps          [edi], xmm1
        add             esi, 6
        add             edi, 16
        sub             ecx, 1
        jnz             loop2
        
        pop             esi
        pop             edi
    }
}

static __forceinline void fill_line_right2(BYTE* src, BYTE* dest, int pitch, int xloop, int xloop2)
{
    __asm
    {
        push            edi
        push            esi
        mov             edi, dest
        mov             eax, pitch
        mov             esi, src
        mov             ecx, xloop
        lea             edx, [eax+eax*2]
        
        shl             ecx, 1
        lea             ecx, [ecx+ecx*2]
        add             ecx, esi
        pinsrw          xmm2, [ecx+edx-6], 7
        mov             ecx, xloop2
    align 16
    loop2:
        movaps          xmm0, xmm2
        pinsrw          xmm0, [esi      ], 1
        pinsrw          xmm0, [esi+eax  ], 3
        pinsrw          xmm0, [esi+eax*2], 5
        psrad           xmm0, 16
        cvtdq2ps        xmm1, xmm0
        movaps          [edi], xmm1
        add             esi, 6
        add             edi, 16
        sub             ecx, 1
        jnz             loop2
        
        pop             esi
        pop             edi
    }
}

static __forceinline void fill_line(BYTE* src, BYTE* dest, int pitch, int xloop, int xloop2, int xloop3)
{
    BYTE* src2 = src + xloop*6;
    __asm
    {
        push            edi
        push            esi
        mov             esi, src2
        mov             edi, dest
        pinsrw          xmm2, [esi], 1
        mov             eax, pitch
        mov             esi, src
        lea             edx, [eax+eax*2]
        mov             ecx, xloop
    align 16
    loop1:
        movdqa          xmm0, xmm2
        pinsrw          xmm0, [esi+eax  ], 3
        pinsrw          xmm0, [esi+eax*2], 5
        pinsrw          xmm0, [esi+edx  ], 7
        psrad           xmm0, 16
        cvtdq2ps        xmm1, xmm0
        movaps          [edi], xmm1
        add             esi, 6
        add             edi, 16
        sub             ecx, 1
        jnz             loop1
        
        mov             ecx, xloop2
        sub             ecx, 1
    align 16
    loop2:
        pxor            xmm0, xmm0
        pxor            xmm1, xmm1
        pinsrw          xmm0, [esi        ], 1
        pinsrw          xmm1, [esi      +6], 1
        pinsrw          xmm0, [esi+eax    ], 3
        pinsrw          xmm1, [esi+eax  +6], 3
        pinsrw          xmm0, [esi+eax*2  ], 5
        pinsrw          xmm1, [esi+eax*2+6], 5
        pinsrw          xmm0, [esi+edx    ], 7
        pinsrw          xmm1, [esi+edx  +6], 7
        psrad           xmm0, 16
        psrad           xmm1, 16
        cvtdq2ps        xmm2, xmm0
        cvtdq2ps        xmm3, xmm1
        movaps          [edi], xmm2
        movaps          [edi+16], xmm3
        add             esi, 12
        add             edi, 32
        sub             ecx, 2
        jnle            loop2
        add             ecx, 1
        jz              loop2end
        
        pinsrw          xmm0, [esi      ], 1
        pinsrw          xmm0, [esi+eax  ], 3
        pinsrw          xmm0, [esi+eax*2], 5
        pinsrw          xmm0, [esi+edx  ], 7
        psrad           xmm0, 16
        cvtdq2ps        xmm1, xmm0
        movaps          [edi], xmm1
        add             esi, 6
        add             edi, 16
    
    loop2end:
        pinsrw          xmm2, [esi+edx-6], 7
        mov             ecx, xloop3
    align 16
    loop3:
        movaps          xmm0, xmm2
        pinsrw          xmm0, [esi      ], 1
        pinsrw          xmm0, [esi+eax  ], 3
        pinsrw          xmm0, [esi+eax*2], 5
        psrad           xmm0, 16
        cvtdq2ps        xmm1, xmm0
        movaps          [edi], xmm1
        add             esi, 6
        add             edi, 16
        sub             ecx, 1
        jnz             loop3
        
        pop            esi
        pop            edi
    }
}

static void make_lumabuf2(int xloop1, int xloop2, int xloop3, int pitch, BYTE* src, BYTE* dest)
{
    if (xloop1 != 0)
    {
        if (xloop3 == 0)
        {
            fill_line_left(src, dest, pitch, xloop1, xloop2);
        }
        else
        {
            fill_line(src, dest, pitch, xloop1, xloop2, xloop3);
        }
    }
    else
    {
        if (xloop3 == 0)
        {
            fill_line_center(src, dest, pitch, xloop2);
        }
        else if(xloop2 > 0)
        {
            fill_line_right(src, dest, pitch, xloop2, xloop3);
        }
        else
        {
            fill_line_right2(src, dest, pitch, xloop2, xloop3);
        }
    }
}

static void nlmeans_luma_filter_gw( int thread_id,int thread_num,void *param1,void *param2 )
{
    FILTER_PARAM* prm = (FILTER_PARAM*)param1;
    const int xblocks = prm->xblocks;
    LONG* atomic_counter = (LONG*)(&prm->atomic_counter);
    const int radius = prm->radius;
    const int src_bpl = prm->src_bpl;
    const int temp_bpl = prm->temp_bpl;
    const int pitch = prm->pitch;
    const int width = prm->width;
    const int height = prm->height;
    const int maxblock = prm->maxblock;
    const int span = prm->span;
    
    BYTE* diffbuf = prm->work + worksize * thread_id;
    BYTE* weightbuf = diffbuf + DIFFBUF_BPL * 2;
    BYTE* lumabuf = weightbuf + WEIGHTBUF_BPL * (radius + 2);
    BYTE* ycp_edit = prm->ycp_edit;
    BYTE* ycp_temp = prm->ycp_temp;
    BYTE* _temp = lumabuf + LUMABUF_BPL * (v_blocksize+(MAX_RADIUS+1)*2);
    int dest2src = ycp_edit - ycp_temp;
    
    while (TRUE)
    {
        int block = InterlockedIncrement(atomic_counter) - 1;
        if (block >= maxblock) break;
        int y_start = block * v_blocksize;
        int y_end = y_start + v_blocksize;
        if (y_end > height) y_end = height;
        BYTE* _src = ycp_edit + y_start * src_bpl;
        BYTE* _dest = ycp_temp + y_start * src_bpl;
        if (y_start != 0) _src -= (radius+1) * src_bpl;
        for(int x=0; x<span; x+= H_BLOCKSIZE/4)
        {
            int x_start = x;
            int x_end = x + H_BLOCKSIZE/4;
            if(x_end > span) x_end = span;
            int xloopcount = x_end - x_start;
            int xloopcount3 = xloopcount + radius * 2;
            BYTE* temp = _temp + x_start * 2 * 4;
            BYTE* src = _src + (x_start - (radius + 1)) * 6;
            int xloop1, xloop2, xloop3;
            int rightpixel = span * 3 + x_end;
            if (x_start == 0) xloop1 = radius + 1;
            else xloop1 = 0;
            if (rightpixel + radius < width) xloop3 = 0;
            else xloop3 = rightpixel + radius + 1 - width;
            xloop2 = xloopcount + (radius + 1)*2 - xloop1 - xloop3;
            BYTE* lumabuf2 = lumabuf;
            for(int y=0; y<radius+1; y++)
            {
                make_lumabuf2(xloop1, xloop2, xloop3, pitch, src, lumabuf2);
                lumabuf2 += LUMABUF_BPL;
                if(y_start != 0) src += src_bpl;
            }
            BYTE* lumasrc = lumabuf + (radius + 1) * (LUMABUF_BPL + 16);
            for(int y=0; y<radius; y++)
            {
                BYTE* src2 = lumasrc + y * LUMABUF_BPL - radius * 16;
                BYTE* weightbuf2 = weightbuf + y * WEIGHTBUF_BPL;
                make_lumabuf2(xloop1, xloop2, xloop3, pitch, src, lumabuf2);
                lumabuf2 += LUMABUF_BPL;
                if(y_start + y + 1 < height) src += src_bpl;
                __asm
                {
                    mov             edx, src2
                    mov             eax, weightbuf2
                    mov             ecx, xloopcount3
                    movaps          xmm2, f128_1
                align 16
                loop_a:
                    movaps          xmm0, [edx]
                    movaps          xmm1, [edx+16]
                    movaps          [eax+32], xmm2
                    movaps          [eax+80], xmm2
                    movaps          [eax   ], xmm0
                    movaps          [eax+16], xmm0
                    movaps          [eax+48], xmm1
                    movaps          [eax+64], xmm1
                    add             edx, 32
                    add             eax, 96
                    sub             ecx, 2
                    jnle            loop_a
                }
            }
            make_lumabuf2(xloop1, xloop2, xloop3, pitch, src, lumabuf2);
            lumabuf2 += LUMABUF_BPL;
            if(y_start + radius + 1 < height) src += src_bpl;
            for(int y=0; y<radius; y++)
            {
                BYTE* src2 = lumasrc + (y-1) * LUMABUF_BPL - 16;
                BYTE* weightbuf2 = weightbuf + y * WEIGHTBUF_BPL + radius * 48;
                for(int i=-radius; i < -y; i++)
                {
                    for(int j=-radius; j <=radius; j++)
                    {
                        BYTE* src3 = src2 + i * LUMABUF_BPL + j * 16;
                        __asm
                        {
                            push            esi
                            push            edi
                            mov             ecx, xloopcount
                            mov             esi, src3
                            mov             edx, src2
                            mov             edi, diffbuf
                            movaps          xmm6, f128_gw1
                            movaps          xmm7, f128_gw2
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+LUMABUF_BPL]
                            movaps          xmm2, [esi+LUMABUF_BPL*2]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+LUMABUF_BPL]
                            subps           xmm2, [edx+LUMABUF_BPL*2]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            mulps           xmm2, xmm2
                            movaps          xmm3, [esi+16]
                            movaps          xmm4, [esi+LUMABUF_BPL+16]
                            movaps          xmm5, [esi+LUMABUF_BPL*2+16]
                            subps           xmm3, [edx+16]
                            subps           xmm4, [edx+LUMABUF_BPL+16]
                            subps           xmm5, [edx+LUMABUF_BPL*2+16]
                            mulps           xmm3, xmm3
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm2, xmm0
                            addps           xmm5, xmm3
                            mulps           xmm1, xmm6
                            mulps           xmm2, xmm7
                            movaps          xmm0, xmm4
                            mulps           xmm0, xmm6
                            addps           xmm1, xmm2
                            movaps          xmm3, xmm5
                            mulps           xmm3, xmm7
                            mulps           xmm5, xmm6
                            addps           xmm4, xmm1
                            addps           xmm3, xmm0
                            addps           xmm4, xmm5
                            add             esi, 32
                            add             edx, 32
                            
                        align 16
                        loop1:
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+LUMABUF_BPL]
                            movaps          xmm2, [esi+LUMABUF_BPL*2]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+LUMABUF_BPL]
                            subps           xmm2, [edx+LUMABUF_BPL*2]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            mulps           xmm2, xmm2
                            addps           xmm3, xmm1
                            addps           xmm0, xmm2
                            mulps           xmm1, xmm6
                            movaps          xmm2, xmm0
                            mulps           xmm2, xmm6
                            mulps           xmm0, xmm7
                            movaps          xmm5, xmm4
                            addps           xmm5, xmm1
                            movaps          xmm4, xmm3
                            addps           xmm4, xmm2
                            addps           xmm5, xmm0
                            movaps          xmm3, xmm1
                            addps           xmm3, xmm0
                            mulps           xmm5, f128_fastexp2_a
                            movaps          [edi], xmm5
                            add             esi, 16
                            add             edx, 16
                            add             edi, 16
                            sub             ecx, 1
                            jnz             loop1
                            
                            mov             esi, src3
                            mov             ecx, xloopcount
                            mov             edx, diffbuf
                            mov             edi, weightbuf2
                            add             esi, LUMABUF_BPL+16
                            movaps          xmm6, f128_fastexp2_bmc
                            movaps          xmm7, f128_fastexp2_min
                            sub             ecx, 1
                            jz              loop2_end
                        align 16
                        loop2:
                            movaps          xmm2, [edx]
                            movaps          xmm3, [edx+16]
                            movaps          xmm0, xmm2
                            movaps          xmm1, xmm3
                            cmpnltps        xmm0, xmm7
                            cmpnltps        xmm1, xmm7
                            addps           xmm2, xmm6
                            addps           xmm3, xmm6
                            cvtps2dq        xmm2, xmm2
                            cvtps2dq        xmm3, xmm3
                            andps           xmm2, xmm0
                            andps           xmm3, xmm1
                            movaps          xmm4, [esi   ]
                            movaps          xmm5, [esi+16]
                            mulps           xmm4, xmm2
                            mulps           xmm5, xmm3
                            addps           xmm2, [edi+32]
                            addps           xmm3, [edi+80]
                            addps           xmm4, [edi+16]
                            addps           xmm5, [edi+64]
                            movaps          [edi+32], xmm2
                            movaps          [edi+80], xmm3
                            movaps          [edi+16], xmm4
                            movaps          [edi+64], xmm5
                            add             edx, 32
                            add             esi, 32
                            add             edi, 96
                            sub             ecx, 2
                            jnle            loop2
                        loop2_end:
                            add             ecx, 1
                            jz              loop2_end2
                            movaps          xmm2, [edx]
                            movaps          xmm0, xmm2
                            cmpnltps        xmm0, xmm7
                            addps           xmm2, xmm6
                            cvtps2dq        xmm2, xmm2
                            andps           xmm2, xmm0
                            movaps          xmm4, [esi   ]
                            mulps           xmm4, xmm2
                            addps           xmm2, [edi+32]
                            addps           xmm4, [edi+16]
                            movaps          [edi+32], xmm2
                            movaps          [edi+16], xmm4
                        loop2_end2:
                            pop            edi
                            pop            esi
                        }
                    }
                }
            }

            BYTE* weightbuf_rows[6];
            for(int i=0; i<radius+2; i++)
            {
                weightbuf_rows[i] = weightbuf + WEIGHTBUF_BPL * i + radius * 48;
            }
            for(int y=y_start; y<y_end; y+=2)
            {
                BYTE* src2 = lumasrc + (LUMABUF_BPL-16) * radius;
                BYTE* weightbuf2 = weightbuf_rows[radius] - radius * 48;
                BYTE* weightbuf3 = weightbuf_rows[radius+1] - radius * 48;
                make_lumabuf2(xloop1, xloop2, xloop3, pitch, src, lumabuf2);
                lumabuf2 += LUMABUF_BPL;
                if (y + radius + 2 < height) src += src_bpl;
                __asm
                {
                    mov             esi, src2
                    mov             edi, weightbuf2
                    mov             edx, weightbuf3
                    mov             ecx, xloopcount3
                    sub             edx, edi
                    movaps          xmm2, f128_1
                align 16
                loop_b:
                    movaps          xmm0, [esi]
                    movaps          xmm1, [esi+LUMABUF_BPL]
                    movaps          [edi+32    ], xmm2
                    movaps          [edi+edx+32], xmm2
                    movaps          [edi       ], xmm0
                    movaps          [edi+16    ], xmm0
                    movaps          [edi+edx   ], xmm1
                    movaps          [edi+edx+16], xmm1
                    add             esi, 16
                    add             edi, 48
                    sub             ecx, 1
                    jnz             loop_b
                }
                make_lumabuf2(xloop1, xloop2, xloop3, pitch, src, lumabuf2);
                lumabuf2 += LUMABUF_BPL;
                if (y + radius +3 < height) src += src_bpl;
                
                src2 = lumasrc - LUMABUF_BPL - (radius + 1) * 16;
                for(int i=0; i <= radius; i++)
                {
                    for (int j=1; j <= radius; j++)
                    {
                        BYTE* src3 = src2 + i * LUMABUF_BPL + j * 16;
                        BYTE* weightbuf2 = weightbuf_rows[i] + (j-radius) * 48;
                        BYTE* weightbuf3 = weightbuf_rows[i+1] + (j-radius) * 48;
                        __asm
                        {
                            push            esi
                            push            edi
                            mov             ecx, radius
                            mov             esi, src3
                            mov             edx, src2
                            mov             edi, diffbuf
                            movaps          xmm6, f128_gw1
                            movaps          xmm7, f128_gw2
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+LUMABUF_BPL]
                            movaps          xmm2, [esi+LUMABUF_BPL*2]
                            movaps          xmm3, [esi+LUMABUF_BPL*3]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+LUMABUF_BPL]
                            subps           xmm2, [edx+LUMABUF_BPL*2]
                            subps           xmm3, [edx+LUMABUF_BPL*3]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            addps           xmm0, xmm2
                            addps           xmm3, xmm1
                            mulps           xmm1, xmm6
                            mulps           xmm2, xmm6
                            mulps           xmm0, xmm7
                            mulps           xmm3, xmm7
                            addps           xmm0, xmm1
                            movaps          xmm1, xmm2
                            addps           xmm1, xmm3
                            movaps          xmm2, [esi+16]
                            movaps          xmm3, [esi+LUMABUF_BPL*2+16]
                            subps           xmm2, [edx+16]
                            subps           xmm3, [edx+LUMABUF_BPL*2+16]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            addps           xmm1, xmm3
                            addps           xmm2, xmm3
                            mulps           xmm3, xmm6
                            movaps          xmm4, xmm2
                            mulps           xmm4, xmm6
                            mulps           xmm2, xmm7
                            addps           xmm0, xmm4
                            movaps          xmm4, [esi+LUMABUF_BPL+16]
                            movaps          xmm5, [esi+LUMABUF_BPL*3+16]
                            subps           xmm4, [edx+LUMABUF_BPL+16]
                            subps           xmm5, [edx+LUMABUF_BPL*3+16]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm0, xmm4
                            addps           xmm5, xmm4
                            mulps           xmm4, xmm6
                            movaps          [edi], xmm0
                            movaps          xmm0, xmm5
                            mulps           xmm0, xmm6
                            mulps           xmm5, xmm7
                            addps           xmm1, xmm0
                            addps           xmm4, xmm2
                            addps           xmm5, xmm3
                            movaps          [edi+16], xmm1
                            add             esi, 32
                            add             edx, 32
                        align 16
                        loop3:
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+LUMABUF_BPL*2]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+LUMABUF_BPL*2]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            addps           xmm0, xmm1
                            addps           xmm5, xmm1
                            movaps          xmm2, xmm0
                            mulps           xmm2, xmm6
                            mulps           xmm0, xmm7
                            mulps           xmm1, xmm6
                            addps           xmm4, xmm2
                            movaps          xmm2, [esi+LUMABUF_BPL]
                            movaps          xmm3, [esi+LUMABUF_BPL*3]
                            subps           xmm2, [edx+LUMABUF_BPL]
                            subps           xmm3, [edx+LUMABUF_BPL*3]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            addps           xmm4, xmm2
                            addps           xmm3, xmm2
                            movaps          [edi+32], xmm4
                            movaps          xmm4, xmm2
                            mulps           xmm4, xmm6
                            movaps          xmm2, xmm3
                            mulps           xmm2, xmm6
                            mulps           xmm3, xmm7
                            addps           xmm4, xmm0
                            addps           xmm2, xmm5
                            movaps          xmm5, xmm1
                            addps           xmm5, xmm3
                            movaps          [edi+48], xmm2
                            movaps          xmm0, xmm4
                            addps           xmm0, [edi]
                            movaps          xmm1, xmm5
                            addps           xmm1, [edi+16]
                            mulps           xmm0, f128_fastexp2_a
                            mulps           xmm1, f128_fastexp2_a
                            movaps          [edi], xmm0
                            movaps          [edi+16], xmm1
                            add             esi, 16
                            add             edx, 16
                            add             edi, 32
                            sub             ecx, 1
                            jnz             loop3
                            
                            mov             esi, src2
                            mov             ecx, radius
                            mov             edx, diffbuf
                            add             esi, LUMABUF_BPL+16
                            mov             edi, weightbuf2
                            mov             eax, weightbuf3
                            movaps          xmm6, f128_fastexp2_bmc
                            movaps          xmm7, f128_fastexp2_min
                        align 16
                        loop4:
                            movaps          xmm2, [edx]
                            movaps          xmm3, [edx+16]
                            movaps          xmm0, xmm2
                            movaps          xmm1, xmm3
                            cmpnltps        xmm0, xmm7
                            cmpnltps        xmm1, xmm7
                            addps           xmm2, xmm6
                            addps           xmm3, xmm6
                            cvtps2dq        xmm2, xmm2
                            cvtps2dq        xmm3, xmm3
                            andps           xmm2, xmm0
                            andps           xmm3, xmm1
                            movaps          xmm4, [esi]
                            movaps          xmm5, [esi+LUMABUF_BPL]
                            mulps           xmm4, xmm2
                            mulps           xmm5, xmm3
                            addps           xmm2, [edi+32]
                            addps           xmm3, [eax+32]
                            addps           xmm4, [edi+16]
                            addps           xmm5, [eax+16]
                            movaps          [edi+32], xmm2
                            movaps          [eax+32], xmm3
                            movaps          [edi+16], xmm4
                            movaps          [eax+16], xmm5
                            add             edx, 32
                            add             esi, 16
                            add             edi, 48
                            add             eax, 48
                            sub             ecx, 1
                            jnz             loop4
                            pop             edi
                            pop             esi
                        }
                    }
                }

                src2 = lumasrc - LUMABUF_BPL - 16;
                weightbuf2 = weightbuf_rows[0];
                weightbuf3 = weightbuf_rows[1];
                for (int i=0; i <=radius; i++)
                {
                    int j_start;
                    if (i == 0) j_start = 1;
                    else j_start = -radius;
                    for(int j=j_start; j<=radius; j++)
                    {
                        BYTE* src3 = src2 + i * LUMABUF_BPL + j * 16;
                        BYTE* weightbuf4 = weightbuf_rows[i] + j * 48;
                        BYTE* weightbuf5 = weightbuf_rows[i+1] + j * 48;
                        __asm
                        {
                            push            esi
                            push            edi
                            mov             ecx, xloopcount
                            mov             esi, src3
                            mov             edx, src2
                            mov             edi, diffbuf
                            movaps          xmm6, f128_gw1
                            movaps          xmm7, f128_gw2
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+LUMABUF_BPL]
                            movaps          xmm2, [esi+LUMABUF_BPL*2]
                            movaps          xmm3, [esi+LUMABUF_BPL*3]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+LUMABUF_BPL]
                            subps           xmm2, [edx+LUMABUF_BPL*2]
                            subps           xmm3, [edx+LUMABUF_BPL*3]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            addps           xmm0, xmm2
                            addps           xmm3, xmm1
                            mulps           xmm1, xmm6
                            mulps           xmm2, xmm6
                            mulps           xmm0, xmm7
                            mulps           xmm3, xmm7
                            addps           xmm0, xmm1
                            movaps          xmm1, xmm2
                            addps           xmm1, xmm3
                            movaps          xmm2, [esi+16]
                            movaps          xmm3, [esi+LUMABUF_BPL*2+16]
                            subps           xmm2, [edx+16]
                            subps           xmm3, [edx+LUMABUF_BPL*2+16]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            addps           xmm1, xmm3
                            addps           xmm2, xmm3
                            mulps           xmm3, xmm6
                            movaps          xmm4, xmm2
                            mulps           xmm4, xmm6
                            mulps           xmm2, xmm7
                            addps           xmm0, xmm4
                            movaps          xmm4, [esi+LUMABUF_BPL+16]
                            movaps          xmm5, [esi+LUMABUF_BPL*3+16]
                            subps           xmm4, [edx+LUMABUF_BPL+16]
                            subps           xmm5, [edx+LUMABUF_BPL*3+16]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm0, xmm4
                            addps           xmm5, xmm4
                            mulps           xmm4, xmm6
                            movaps          [edi], xmm0
                            movaps          xmm0, xmm5
                            mulps           xmm0, xmm6
                            mulps           xmm5, xmm7
                            addps           xmm1, xmm0
                            addps           xmm4, xmm2
                            addps           xmm5, xmm3
                            movaps          [edi+DIFFBUF_BPL], xmm1
                            add             esi, 32
                            add             edx, 32
                        align 16
                        loop5:
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+LUMABUF_BPL*2]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+LUMABUF_BPL*2]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            addps           xmm0, xmm1
                            addps           xmm5, xmm1
                            movaps          xmm2, xmm0
                            mulps           xmm2, xmm6
                            mulps           xmm0, xmm7
                            mulps           xmm1, xmm6
                            addps           xmm4, xmm2
                            movaps          xmm2, [esi+LUMABUF_BPL]
                            movaps          xmm3, [esi+LUMABUF_BPL*3]
                            subps           xmm2, [edx+LUMABUF_BPL]
                            subps           xmm3, [edx+LUMABUF_BPL*3]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            addps           xmm4, xmm2
                            addps           xmm3, xmm2
                            movaps          [edi+16], xmm4
                            movaps          xmm4, xmm2
                            mulps           xmm4, xmm6
                            movaps          xmm2, xmm3
                            mulps           xmm2, xmm6
                            mulps           xmm3, xmm7
                            addps           xmm4, xmm0
                            addps           xmm2, xmm5
                            movaps          xmm5, xmm1
                            addps           xmm5, xmm3
                            movaps          [edi+DIFFBUF_BPL+16], xmm2
                            movaps          xmm0, xmm4
                            addps           xmm0, [edi]
                            movaps          xmm1, xmm5
                            addps           xmm1, [edi+DIFFBUF_BPL]
                            mulps           xmm0, f128_fastexp2_a
                            mulps           xmm1, f128_fastexp2_a
                            movaps          [edi], xmm0
                            movaps          [edi+DIFFBUF_BPL], xmm1
                            add             esi, 16
                            add             edx, 16
                            add             edi, 16
                            sub             ecx, 1
                            jnz             loop5

                            mov             ecx, xloopcount
                            mov             edx, diffbuf
                            mov             edi, weightbuf2
                            mov             esi, weightbuf4
                            movaps          xmm6, f128_fastexp2_bmc
                            movaps          xmm7, f128_fastexp2_min
                            mov             eax, 2
                        loop7:
                            sub             ecx, 1
                            jz              loop6_end
                        align 16
                        loop6:
                            movaps          xmm2, [edx]
                            movaps          xmm3, [edx+16]
                            movaps          xmm0, xmm2
                            movaps          xmm1, xmm3
                            cmpnltps        xmm0, xmm7
                            cmpnltps        xmm1, xmm7
                            addps           xmm2, xmm6
                            addps           xmm3, xmm6
                            cvtps2dq        xmm2, xmm2
                            cvtps2dq        xmm3, xmm3
                            andps           xmm2, xmm0
                            andps           xmm3, xmm1
                            movaps          xmm4, [edi+32 ]
                            movaps          xmm5, [edi+80]
                            addps           xmm4, xmm2
                            addps           xmm5, xmm3
                            movaps          [edi+32 ], xmm4
                            movaps          [edi+80], xmm5
                            movaps          xmm0, [esi+32 ]
                            movaps          xmm1, [esi+80]
                            movaps          xmm4, [esi    ]
                            movaps          xmm5, [esi+48 ]
                            addps           xmm0, xmm2
                            addps           xmm1, xmm3
                            movaps          [esi+32 ], xmm0
                            movaps          [esi+80], xmm1
                            movaps          xmm0, [edi+16 ]
                            movaps          xmm1, [edi+64 ]
                            mulps           xmm4, xmm2
                            mulps           xmm5, xmm3
                            addps           xmm4, xmm0
                            addps           xmm5, xmm1
                            movaps          xmm0, [edi    ]
                            movaps          xmm1, [edi+48 ]
                            movaps          [edi+16 ], xmm4
                            movaps          [edi+64 ], xmm5
                            movaps          xmm4, [esi+16 ]
                            movaps          xmm5, [esi+64 ]
                            mulps           xmm0, xmm2
                            mulps           xmm1, xmm3
                            addps           xmm0, xmm4
                            addps           xmm1, xmm5
                            movaps          [esi+16 ], xmm0
                            movaps          [esi+64 ], xmm1
                            add             edx, 32
                            add             edi, 96
                            add             esi, 96
                            sub             ecx, 2
                            jnle            loop6
                        loop6_end:
                            add             ecx, 1
                            jz              loop6_end2
                            movaps          xmm2, [edx]
                            movaps          xmm0, xmm2
                            cmpnltps        xmm0, xmm7
                            addps           xmm2, xmm6
                            cvtps2dq        xmm2, xmm2
                            andps           xmm2, xmm0
                            movaps          xmm4, [edi+32 ]
                            addps           xmm4, xmm2
                            movaps          [edi+32 ], xmm4
                            movaps          xmm0, [esi+32 ]
                            movaps          xmm4, [esi    ]
                            addps           xmm0, xmm2
                            movaps          [esi+32 ], xmm0
                            movaps          xmm0, [edi+16 ]
                            mulps           xmm4, xmm2
                            addps           xmm4, xmm0
                            movaps          xmm0, [edi    ]
                            movaps          [edi+16 ], xmm4
                            movaps          xmm4, [esi+16 ]
                            mulps           xmm0, xmm2
                            addps           xmm0, xmm4
                            movaps          [esi+16 ], xmm0
                        loop6_end2:
                            sub             eax, 1
                            jz              loop7_end
                            
                            mov             ecx, xloopcount
                            mov             edx, diffbuf
                            mov             edi, weightbuf3
                            mov             esi, weightbuf5
                            add             edx, DIFFBUF_BPL
                            jmp             loop7
                        loop7_end:
                            pop             edi
                            pop             esi
                        }
                    }
                }

                src2 = lumasrc + xloopcount * 16 - LUMABUF_BPL - 16;
                for(int i=1; i <= radius; i++)
                {
                    for (int j=-radius; j < 0; j++)
                    {
                        BYTE* src3 = src2 + i * LUMABUF_BPL + j * 16;
                        BYTE* weightbuf2 = weightbuf_rows[i] + (xloopcount + j) * 48;
                        BYTE* weightbuf3 = weightbuf_rows[i+1] + (xloopcount + j) * 48;
                        __asm
                        {
                            push            esi
                            push            edi
                            mov             ecx, radius
                            mov             esi, src3
                            mov             edx, src2
                            mov             edi, diffbuf
                            movaps          xmm6, f128_gw1
                            movaps          xmm7, f128_gw2
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+LUMABUF_BPL]
                            movaps          xmm2, [esi+LUMABUF_BPL*2]
                            movaps          xmm3, [esi+LUMABUF_BPL*3]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+LUMABUF_BPL]
                            subps           xmm2, [edx+LUMABUF_BPL*2]
                            subps           xmm3, [edx+LUMABUF_BPL*3]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            addps           xmm0, xmm2
                            addps           xmm3, xmm1
                            mulps           xmm1, xmm6
                            mulps           xmm2, xmm6
                            mulps           xmm0, xmm7
                            mulps           xmm3, xmm7
                            addps           xmm0, xmm1
                            movaps          xmm1, xmm2
                            addps           xmm1, xmm3
                            movaps          xmm2, [esi+16]
                            movaps          xmm3, [esi+LUMABUF_BPL*2+16]
                            subps           xmm2, [edx+16]
                            subps           xmm3, [edx+LUMABUF_BPL*2+16]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            addps           xmm1, xmm3
                            addps           xmm2, xmm3
                            mulps           xmm3, xmm6
                            movaps          xmm4, xmm2
                            mulps           xmm4, xmm6
                            mulps           xmm2, xmm7
                            addps           xmm0, xmm4
                            movaps          xmm4, [esi+LUMABUF_BPL+16]
                            movaps          xmm5, [esi+LUMABUF_BPL*3+16]
                            subps           xmm4, [edx+LUMABUF_BPL+16]
                            subps           xmm5, [edx+LUMABUF_BPL*3+16]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm0, xmm4
                            addps           xmm5, xmm4
                            mulps           xmm4, xmm6
                            movaps          [edi], xmm0
                            movaps          xmm0, xmm5
                            mulps           xmm0, xmm6
                            mulps           xmm5, xmm7
                            addps           xmm1, xmm0
                            addps           xmm4, xmm2
                            addps           xmm5, xmm3
                            movaps          [edi+16], xmm1
                            add             esi, 32
                            add             edx, 32
                        align 16
                        loop8:
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+LUMABUF_BPL*2]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+LUMABUF_BPL*2]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            addps           xmm0, xmm1
                            addps           xmm5, xmm1
                            movaps          xmm2, xmm0
                            mulps           xmm2, xmm6
                            mulps           xmm0, xmm7
                            mulps           xmm1, xmm6
                            addps           xmm4, xmm2
                            movaps          xmm2, [esi+LUMABUF_BPL]
                            movaps          xmm3, [esi+LUMABUF_BPL*3]
                            subps           xmm2, [edx+LUMABUF_BPL]
                            subps           xmm3, [edx+LUMABUF_BPL*3]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            addps           xmm4, xmm2
                            addps           xmm3, xmm2
                            movaps          [edi+32], xmm4
                            movaps          xmm4, xmm2
                            mulps           xmm4, xmm6
                            movaps          xmm2, xmm3
                            mulps           xmm2, xmm6
                            mulps           xmm3, xmm7
                            addps           xmm4, xmm0
                            addps           xmm2, xmm5
                            movaps          xmm5, xmm1
                            addps           xmm5, xmm3
                            movaps          [edi+48], xmm2
                            movaps          xmm0, xmm4
                            addps           xmm0, [edi]
                            movaps          xmm1, xmm5
                            addps           xmm1, [edi+16]
                            mulps           xmm0, f128_fastexp2_a
                            mulps           xmm1, f128_fastexp2_a
                            movaps          [edi], xmm0
                            movaps          [edi+16], xmm1
                            add             esi, 16
                            add             edx, 16
                            add             edi, 32
                            sub             ecx, 1
                            jnz             loop8

                            mov             esi, src2
                            mov             ecx, radius
                            mov             edx, diffbuf
                            add             esi, LUMABUF_BPL+16
                            mov             edi, weightbuf2
                            mov             eax, weightbuf3
                            movaps          xmm6, f128_fastexp2_bmc
                            movaps          xmm7, f128_fastexp2_min
                        align 16
                        loop9:
                            movaps          xmm2, [edx]
                            movaps          xmm3, [edx+16]
                            movaps          xmm0, xmm2
                            movaps          xmm1, xmm3
                            cmpnltps        xmm0, xmm7
                            cmpnltps        xmm1, xmm7
                            addps           xmm2, xmm6
                            addps           xmm3, xmm6
                            cvtps2dq        xmm2, xmm2
                            cvtps2dq        xmm3, xmm3
                            andps           xmm2, xmm0
                            andps           xmm3, xmm1
                            movaps          xmm4, [esi]
                            movaps          xmm5, [esi+LUMABUF_BPL]
                            mulps           xmm4, xmm2
                            mulps           xmm5, xmm3
                            addps           xmm2, [edi+32]
                            addps           xmm3, [eax+32]
                            addps           xmm4, [edi+16]
                            addps           xmm5, [eax+16]
                            movaps          [edi+32], xmm2
                            movaps          [eax+32], xmm3
                            movaps          [edi+16], xmm4
                            movaps          [eax+16], xmm5
                            add             edx, 32
                            add             esi, 16
                            add             edi, 48
                            add             eax, 48
                            sub             ecx, 1
                            jnz             loop9
                            pop             edi
                            pop             esi
                        }
                    }
                }
                
                weightbuf2 = weightbuf_rows[0];
                weightbuf3 = weightbuf_rows[1];
                __asm
                {
                    push            edi
                    push            esi
                    mov             edx, weightbuf2
                    mov             esi, weightbuf3
                    mov             edi, temp
                    mov             eax, temp_bpl
                    mov             ecx, xloopcount
                align 16
                loop10:
                    rcpps           xmm0, [edx+32]
                    rcpps           xmm1, [edx+80]
                    rcpps           xmm2, [esi+32]
                    rcpps           xmm3, [esi+80]
                    mulps           xmm0, [edx+16]
                    mulps           xmm1, [edx+64]
                    mulps           xmm2, [esi+16]
                    mulps           xmm3, [esi+64]
                    cvtps2dq        xmm0, xmm0
                    cvtps2dq        xmm1, xmm1
                    cvtps2dq        xmm2, xmm2
                    cvtps2dq        xmm3, xmm3
                    packssdw        xmm0, xmm1
                    packssdw        xmm2, xmm3
                    movdqa          [edi], xmm0
                    movdqa          [edi+eax], xmm2
                    add             edx, 96
                    add             esi, 96
                    add             edi, 16
                    sub             ecx, 2
                    jnle            loop10
                    pop             esi
                    pop             edi
                }
                temp += temp_bpl * 2;
                lumasrc += LUMABUF_BPL * 2;
                BYTE* tmp1 = weightbuf_rows[0];
                BYTE* tmp2 = weightbuf_rows[1];
                for(int i=0; i < radius; i++)
                {
                    weightbuf_rows[i] = weightbuf_rows[i+2];
                }
                weightbuf_rows[radius] = tmp1;
                weightbuf_rows[radius+1] = tmp2;
            }
        }
        BYTE* src = _dest + dest2src;
        BYTE* src2 = _temp;
        BYTE* dest = _dest;
        int yloopcount = y_end - y_start;
        int xloopcount = span / 8;
        int xloopcount2 = (width - span * 3 + 7) / 8;
        int srcstep = src_bpl - xloopcount * 48 * 3 - xloopcount2 * 48;
        int tmpstep = temp_bpl - 6;
        __asm
        {
            mov             esi, src
            mov             edx, src2
            mov             edi, dest
        loop_y1:
            mov             ebx, 3
        loop_x2:
            xor             eax, eax
            mov             ecx, xloopcount
        align 16
        loop_x1:
            movdqa          xmm0, [esi]
            movdqa          xmm1, [esi+16]
            movdqa          xmm2, [esi+32]
            pinsrw          xmm0, [edx+eax], 0
            pinsrw          xmm0, [edx+eax+8], 3
            pinsrw          xmm0, [edx+eax+16], 6
            pinsrw          xmm1, [edx+eax+24], 1
            pinsrw          xmm1, [edx+eax+32], 4
            pinsrw          xmm1, [edx+eax+40], 7
            pinsrw          xmm2, [edx+eax+48], 2
            pinsrw          xmm2, [edx+eax+56], 5
            movntdq         [edi], xmm0
            movntdq         [edi+16], xmm1
            movntdq         [edi+32], xmm2
            add             esi, 48
            add             edi, 48
            add             eax, 64
            sub             ecx, 1
            jnz             loop_x1
            add             edx, 2
            sub             ebx, 1
            jnz             loop_x2
            
            xor             eax, eax
            mov             ecx, xloopcount2
        align 16
        loop_x3:
            movdqa          xmm0, [esi]
            movdqa          xmm1, [esi+16]
            movdqa          xmm2, [esi+32]
            pinsrw          xmm0, [edx+eax], 0
            pinsrw          xmm0, [edx+eax+8], 3
            pinsrw          xmm0, [edx+eax+16], 6
            pinsrw          xmm1, [edx+eax+24], 1
            pinsrw          xmm1, [edx+eax+32], 4
            pinsrw          xmm1, [edx+eax+40], 7
            pinsrw          xmm2, [edx+eax+48], 2
            pinsrw          xmm2, [edx+eax+56], 5
            movntdq         [edi], xmm0
            movntdq         [edi+16], xmm1
            movntdq         [edi+32], xmm2
            add             esi, 48
            add             edi, 48
            add             eax, 64
            sub             ecx, 1
            jnz             loop_x3
            
            add             esi, srcstep
            add             edi, srcstep
            add             edx, tmpstep
            sub             yloopcount, 1
            jnz             loop_y1
        }
    }
}

static void nlmeans_luma_filter( int thread_id,int thread_num,void *param1,void *param2 )
{
    FILTER_PARAM* prm = (FILTER_PARAM*)param1;
    const int xblocks = prm->xblocks;
    LONG* atomic_counter = (LONG*)(&prm->atomic_counter);
    const int radius = prm->radius;
    const int src_bpl = prm->src_bpl;
    const int temp_bpl = prm->temp_bpl;
    const int pitch = prm->pitch;
    const int width = prm->width;
    const int height = prm->height;
    const int maxblock = prm->maxblock;
    const int span = prm->span;
    
    BYTE* diffbuf = prm->work + worksize * thread_id;
    BYTE* weightbuf = diffbuf + DIFFBUF_BPL * 2;
    BYTE* lumabuf = weightbuf + WEIGHTBUF_BPL * (radius + 2);
    BYTE* ycp_edit = prm->ycp_edit;
    BYTE* ycp_temp = prm->ycp_temp;
    BYTE* _temp = lumabuf + LUMABUF_BPL * (v_blocksize+(MAX_RADIUS+1)*2);
    int dest2src = ycp_edit - ycp_temp;
    
    while (TRUE)
    {
        int block = InterlockedIncrement(atomic_counter) - 1;
        if (block >= maxblock) break;
        int y_start = block * v_blocksize;
        int y_end = y_start + v_blocksize;
        if (y_end > height) y_end = height;
        BYTE* _src = ycp_edit + y_start * src_bpl;
        BYTE* _dest = ycp_temp + y_start * src_bpl;
        if (y_start != 0) _src -= (radius+1) * src_bpl;
        for(int x=0; x<span; x+= H_BLOCKSIZE/4)
        {
            int x_start = x;
            int x_end = x + H_BLOCKSIZE/4;
            if(x_end > span) x_end = span;
            int xloopcount = x_end - x_start;
            int xloopcount3 = xloopcount + radius * 2;
            BYTE* temp = _temp + x_start * 2 * 4;
            BYTE* src = _src + (x_start - (radius + 1)) * 6;
            int xloop1, xloop2, xloop3;
            int rightpixel = span * 3 + x_end;
            if (x_start == 0) xloop1 = radius + 1;
            else xloop1 = 0;
            if (rightpixel + radius < width) xloop3 = 0;
            else xloop3 = rightpixel + radius + 1 - width;
            xloop2 = xloopcount + (radius + 1)*2 - xloop1 - xloop3;
            BYTE* lumabuf2 = lumabuf;
            for(int y=0; y<radius+1; y++)
            {
                make_lumabuf2(xloop1, xloop2, xloop3, pitch, src, lumabuf2);
                lumabuf2 += LUMABUF_BPL;
                if(y_start != 0) src += src_bpl;
            }
            BYTE* lumasrc = lumabuf + (radius + 1) * (LUMABUF_BPL + 16);
            for(int y=0; y<radius; y++)
            {
                BYTE* src2 = lumasrc + y * LUMABUF_BPL - radius * 16;
                BYTE* weightbuf2 = weightbuf + y * WEIGHTBUF_BPL;
                make_lumabuf2(xloop1, xloop2, xloop3, pitch, src, lumabuf2);
                lumabuf2 += LUMABUF_BPL;
                if(y_start + y + 1 < height) src += src_bpl;
                __asm
                {
                    mov             edx, src2
                    mov             eax, weightbuf2
                    mov             ecx, xloopcount3
                    movaps          xmm2, f128_1
                align 16
                loop_a:
                    movaps          xmm0, [edx]
                    movaps          xmm1, [edx+16]
                    movaps          [eax+32], xmm2
                    movaps          [eax+80], xmm2
                    movaps          [eax   ], xmm0
                    movaps          [eax+16], xmm0
                    movaps          [eax+48], xmm1
                    movaps          [eax+64], xmm1
                    add             edx, 32
                    add             eax, 96
                    sub             ecx, 2
                    jnle            loop_a
                }
            }
            make_lumabuf2(xloop1, xloop2, xloop3, pitch, src, lumabuf2);
            lumabuf2 += LUMABUF_BPL;
            if(y_start + radius + 1 < height) src += src_bpl;
            for(int y=0; y<radius; y++)
            {
                BYTE* src2 = lumasrc + (y-1) * LUMABUF_BPL - 16;
                BYTE* weightbuf2 = weightbuf + y * WEIGHTBUF_BPL + radius * 48;
                for(int i=-radius; i < -y; i++)
                {
                    for(int j=-radius; j <=radius; j++)
                    {
                        BYTE* src3 = src2 + i * LUMABUF_BPL + j * 16;
                        __asm
                        {
                            push            esi
                            push            edi
                            mov             ecx, xloopcount
                            mov             esi, src3
                            mov             edx, src2
                            mov             edi, diffbuf
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+16]
                            movaps          xmm2, [esi+LUMABUF_BPL]
                            movaps          xmm3, [esi+LUMABUF_BPL+16]
                            movaps          xmm4, [esi+LUMABUF_BPL*2]
                            movaps          xmm5, [esi+LUMABUF_BPL*2+16]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+16]
                            subps           xmm2, [edx+LUMABUF_BPL]
                            subps           xmm3, [edx+LUMABUF_BPL+16]
                            subps           xmm4, [edx+LUMABUF_BPL*2]
                            subps           xmm5, [edx+LUMABUF_BPL*2+16]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm0, xmm2
                            addps           xmm1, xmm3
                            addps           xmm0, xmm4
                            addps           xmm1, xmm5
                            add             esi, 32
                            add             edx, 32
                        align 16
                        loop1:
                            movaps          xmm2, [esi]
                            movaps          xmm3, [esi+16]
                            subps           xmm2, [edx]
                            subps           xmm3, [edx+16]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            movaps          xmm4, [esi+LUMABUF_BPL]
                            movaps          xmm5, [esi+LUMABUF_BPL+16]
                            subps           xmm4, [edx+LUMABUF_BPL]
                            subps           xmm5, [edx+LUMABUF_BPL+16]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm2, xmm4
                            addps           xmm3, xmm5
                            movaps          xmm4, [esi+LUMABUF_BPL*2]
                            movaps          xmm5, [esi+LUMABUF_BPL*2+16]
                            subps           xmm4, [edx+LUMABUF_BPL*2]
                            subps           xmm5, [edx+LUMABUF_BPL*2+16]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            movaps          xmm6, xmm0
                            addps           xmm6, xmm1
                            movaps          xmm0, xmm2
                            addps           xmm0, xmm4
                            addps           xmm3, xmm5
                            movaps          xmm7, xmm0
                            addps           xmm7, xmm1
                            addps           xmm6, xmm3
                            addps           xmm7, xmm3
                            mulps           xmm6, f128_fastexp2_a
                            mulps           xmm7, f128_fastexp2_a
                            movaps          [edi], xmm6
                            movaps          [edi+16], xmm7
                            movaps          xmm1, xmm3
                            add             esi, 32
                            add             edx, 32
                            add             edi, 32
                            sub             ecx, 2
                            jnle            loop1
                            
                            mov             esi, src3
                            mov             ecx, xloopcount
                            mov             edx, diffbuf
                            mov             edi, weightbuf2
                            add             esi, LUMABUF_BPL+16
                            movaps          xmm6, f128_fastexp2_bmc
                            movaps          xmm7, f128_fastexp2_min
                            sub             ecx, 1
                            jz              loop2_end
                        align 16
                        loop2:
                            movaps          xmm2, [edx]
                            movaps          xmm3, [edx+16]
                            movaps          xmm0, xmm2
                            movaps          xmm1, xmm3
                            cmpnltps        xmm0, xmm7
                            cmpnltps        xmm1, xmm7
                            addps           xmm2, xmm6
                            addps           xmm3, xmm6
                            cvtps2dq        xmm2, xmm2
                            cvtps2dq        xmm3, xmm3
                            andps           xmm2, xmm0
                            andps           xmm3, xmm1
                            movaps          xmm4, [esi]
                            movaps          xmm5, [esi+16]
                            mulps           xmm4, xmm2
                            mulps           xmm5, xmm3
                            addps           xmm2, [edi+32]
                            addps           xmm3, [edi+80]
                            addps           xmm4, [edi+16]
                            addps           xmm5, [edi+64]
                            movaps          [edi+32], xmm2
                            movaps          [edi+80], xmm3
                            movaps          [edi+16], xmm4
                            movaps          [edi+64], xmm5
                            add             edx, 32
                            add             esi, 32
                            add             edi, 96
                            sub             ecx, 2
                            jnle            loop2
                        loop2_end:
                            add             ecx, 1
                            jz              loop2_end2
                            movaps          xmm2, [edx]
                            movaps          xmm0, xmm2
                            cmpnltps        xmm0, xmm7
                            addps           xmm2, xmm6
                            cvtps2dq        xmm2, xmm2
                            andps           xmm2, xmm0
                            movaps          xmm4, [esi   ]
                            mulps           xmm4, xmm2
                            addps           xmm2, [edi+32]
                            addps           xmm4, [edi+16]
                            movaps          [edi+32], xmm2
                            movaps          [edi+16], xmm4
                        loop2_end2:
                            pop             edi
                            pop             esi
                        }
                    }
                }
            }

            BYTE* weightbuf_rows[6];
            for(int i=0; i<radius+2; i++)
            {
                weightbuf_rows[i] = weightbuf + WEIGHTBUF_BPL * i + radius * 48;
            }
            for(int y=y_start; y<y_end; y+=2)
            {
                BYTE* src2 = lumasrc + (LUMABUF_BPL-16) * radius;
                BYTE* weightbuf2 = weightbuf_rows[radius] - radius * 48;
                BYTE* weightbuf3 = weightbuf_rows[radius+1] - radius * 48;
                make_lumabuf2(xloop1, xloop2, xloop3, pitch, src, lumabuf2);
                lumabuf2 += LUMABUF_BPL;
                if (y + radius + 2 < height) src += src_bpl;
                __asm
                {
                    mov             esi, src2
                    mov             edi, weightbuf2
                    mov             edx, weightbuf3
                    mov             ecx, xloopcount3
                    sub             edx, edi
                    movaps          xmm2, f128_1
                align 16
                loop_b:
                    movaps          xmm0, [esi]
                    movaps          xmm1, [esi+LUMABUF_BPL]
                    movaps          [edi+32    ], xmm2
                    movaps          [edi+edx+32], xmm2
                    movaps          [edi       ], xmm0
                    movaps          [edi+16    ], xmm0
                    movaps          [edi+edx   ], xmm1
                    movaps          [edi+edx+16], xmm1
                    add             esi, 16
                    add             edi, 48
                    sub             ecx, 1
                    jnz             loop_b
                }
                make_lumabuf2(xloop1, xloop2, xloop3, pitch, src, lumabuf2);
                lumabuf2 += LUMABUF_BPL;
                if (y + radius +3 < height) src += src_bpl;

                src2 = lumasrc - LUMABUF_BPL - (radius + 1) * 16;
                for(int i=0; i <= radius; i++)
                {
                    for (int j=1; j <= radius; j++)
                    {
                        BYTE* src3 = src2 + i * LUMABUF_BPL + j * 16;
                        BYTE* weightbuf2 = weightbuf_rows[i] + (j-radius) * 48;
                        BYTE* weightbuf3 = weightbuf_rows[i+1] + (j-radius) * 48;
                        __asm
                        {
                            push            esi
                            push            edi
                            mov             ecx, radius
                            mov             esi, src3
                            mov             edx, src2
                            mov             edi, diffbuf
                            movaps          xmm2, [esi+LUMABUF_BPL]
                            movaps          xmm3, [esi+LUMABUF_BPL+16]
                            subps           xmm2, [edx+LUMABUF_BPL]
                            subps           xmm3, [edx+LUMABUF_BPL+16]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            movaps          xmm4, [esi+LUMABUF_BPL*2]
                            movaps          xmm5, [esi+LUMABUF_BPL*2+16]
                            subps           xmm4, [edx+LUMABUF_BPL*2]
                            subps           xmm5, [edx+LUMABUF_BPL*2+16]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm2, xmm4
                            addps           xmm3, xmm5
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+16]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+16]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            addps           xmm0, xmm2
                            addps           xmm1, xmm3
                            movaps          xmm6, [esi+LUMABUF_BPL*3]
                            movaps          xmm7, [esi+LUMABUF_BPL*3+16]
                            subps           xmm6, [edx+LUMABUF_BPL*3]
                            subps           xmm7, [edx+LUMABUF_BPL*3+16]
                            mulps           xmm6, xmm6
                            mulps           xmm7, xmm7
                            addps           xmm6, xmm2
                            addps           xmm7, xmm3
                            add             esi, 32
                            add             edx, 32
                        align 16
                        loop3:
                            movaps          xmm2, [esi+LUMABUF_BPL]
                            movaps          xmm3, [esi+LUMABUF_BPL*2]
                            subps           xmm2, [edx+LUMABUF_BPL]
                            subps           xmm3, [edx+LUMABUF_BPL*2]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            movaps          xmm4, [esi]
                            movaps          xmm5, [esi+LUMABUF_BPL*3]
                            subps           xmm4, [edx]
                            subps           xmm5, [edx+LUMABUF_BPL*3]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm2, xmm3
                            movaps          xmm3, xmm0
                            addps           xmm3, xmm1
                            movaps          xmm0, xmm1
                            movaps          xmm1, xmm4
                            addps           xmm1, xmm2
                            movaps          xmm4, xmm6
                            addps           xmm4, xmm7
                            movaps          xmm6, xmm7
                            movaps          xmm7, xmm5
                            addps           xmm7, xmm2
                            addps           xmm3, xmm1
                            addps           xmm4, xmm7
                            mulps           xmm3, f128_fastexp2_a
                            mulps           xmm4, f128_fastexp2_a
                            movaps          [edi], xmm3
                            movaps          [edi+16], xmm4
                            add             esi, 16
                            add             edx, 16
                            add             edi, 32
                            sub             ecx, 1
                            jnz             loop3
                            
                            mov             esi, src2
                            mov             ecx, radius
                            mov             edx, diffbuf
                            add             esi, LUMABUF_BPL+16
                            mov             edi, weightbuf2
                            mov             eax, weightbuf3
                            movaps          xmm6, f128_fastexp2_bmc
                            movaps          xmm7, f128_fastexp2_min
                        align 16
                        loop4:
                            movaps          xmm2, [edx]
                            movaps          xmm3, [edx+16]
                            movaps          xmm0, xmm2
                            movaps          xmm1, xmm3
                            cmpnltps        xmm0, xmm7
                            cmpnltps        xmm1, xmm7
                            addps           xmm2, xmm6
                            addps           xmm3, xmm6
                            cvtps2dq        xmm2, xmm2
                            cvtps2dq        xmm3, xmm3
                            andps           xmm2, xmm0
                            andps           xmm3, xmm1
                            movaps          xmm4, [esi]
                            movaps          xmm5, [esi+LUMABUF_BPL]
                            mulps           xmm4, xmm2
                            mulps           xmm5, xmm3
                            addps           xmm2, [edi+32]
                            addps           xmm3, [eax+32]
                            addps           xmm4, [edi+16]
                            addps           xmm5, [eax+16]
                            movaps          [edi+32], xmm2
                            movaps          [eax+32], xmm3
                            movaps          [edi+16], xmm4
                            movaps          [eax+16], xmm5
                            add             edx, 32
                            add             esi, 16
                            add             edi, 48
                            add             eax, 48
                            sub             ecx, 1
                            jnz             loop4
                            pop             edi
                            pop             esi
                        }
                    }
                }

                src2 = lumasrc - LUMABUF_BPL - 16;
                weightbuf2 = weightbuf_rows[0];
                weightbuf3 = weightbuf_rows[1];
                for (int i=0; i <=radius; i++)
                {
                    int j_start;
                    if (i == 0) j_start = 1;
                    else j_start = -radius;
                    for(int j=j_start; j<=radius; j++)
                    {
                        BYTE* src3 = src2 + i * LUMABUF_BPL + j * 16;
                        BYTE* weightbuf4 = weightbuf_rows[i] + j * 48;
                        BYTE* weightbuf5 = weightbuf_rows[i+1] + j * 48;
                        __asm
                        {
                            push            esi
                            push            edi
                            mov             ecx, xloopcount
                            mov             esi, src3
                            mov             edx, src2
                            mov             edi, diffbuf
                            movaps          xmm2, [esi+LUMABUF_BPL]
                            movaps          xmm3, [esi+LUMABUF_BPL+16]
                            subps           xmm2, [edx+LUMABUF_BPL]
                            subps           xmm3, [edx+LUMABUF_BPL+16]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            movaps          xmm4, [esi+LUMABUF_BPL*2]
                            movaps          xmm5, [esi+LUMABUF_BPL*2+16]
                            subps           xmm4, [edx+LUMABUF_BPL*2]
                            subps           xmm5, [edx+LUMABUF_BPL*2+16]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm2, xmm4
                            addps           xmm3, xmm5
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+16]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+16]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            addps           xmm0, xmm2
                            addps           xmm1, xmm3
                            movaps          xmm6, [esi+LUMABUF_BPL*3]
                            movaps          xmm7, [esi+LUMABUF_BPL*3+16]
                            subps           xmm6, [edx+LUMABUF_BPL*3]
                            subps           xmm7, [edx+LUMABUF_BPL*3+16]
                            mulps           xmm6, xmm6
                            mulps           xmm7, xmm7
                            addps           xmm6, xmm2
                            addps           xmm7, xmm3
                            add             esi, 32
                            add             edx, 32
                        align 16
                        loop5:
                            movaps          xmm2, [esi+LUMABUF_BPL]
                            movaps          xmm3, [esi+LUMABUF_BPL*2]
                            subps           xmm2, [edx+LUMABUF_BPL]
                            subps           xmm3, [edx+LUMABUF_BPL*2]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            movaps          xmm4, [esi]
                            movaps          xmm5, [esi+LUMABUF_BPL*3]
                            subps           xmm4, [edx]
                            subps           xmm5, [edx+LUMABUF_BPL*3]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm2, xmm3
                            movaps          xmm3, xmm0
                            addps           xmm3, xmm1
                            movaps          xmm0, xmm1
                            movaps          xmm1, xmm4
                            addps           xmm1, xmm2
                            movaps          xmm4, xmm6
                            addps           xmm4, xmm7
                            movaps          xmm6, xmm7
                            movaps          xmm7, xmm5
                            addps           xmm7, xmm2
                            addps           xmm3, xmm1
                            addps           xmm4, xmm7
                            mulps           xmm3, f128_fastexp2_a
                            mulps           xmm4, f128_fastexp2_a
                            movaps          [edi], xmm3
                            movaps          [edi+DIFFBUF_BPL], xmm4
                            
                            add             esi, 16
                            add             edx, 16
                            add             edi, 16
                            sub             ecx, 1
                            jnz             loop5
                            
                            mov             ecx, xloopcount
                            mov             edx, diffbuf
                            mov             edi, weightbuf2
                            mov             esi, weightbuf4
                            movaps          xmm6, f128_fastexp2_bmc
                            movaps          xmm7, f128_fastexp2_min
                            mov             eax, 2
                        loop7:
                            sub             ecx, 1
                            jz              loop6_end
                            
                        align 16
                        loop6:
                            movaps          xmm2, [edx]
                            movaps          xmm3, [edx+16]
                            movaps          xmm0, xmm2
                            movaps          xmm1, xmm3
                            cmpnltps        xmm0, xmm7
                            cmpnltps        xmm1, xmm7
                            addps           xmm2, xmm6
                            addps           xmm3, xmm6
                            cvtps2dq        xmm2, xmm2
                            cvtps2dq        xmm3, xmm3
                            andps           xmm2, xmm0
                            andps           xmm3, xmm1
                            movaps          xmm4, [edi+32]
                            movaps          xmm5, [edi+80]
                            addps           xmm4, xmm2
                            addps           xmm5, xmm3
                            movaps          [edi+32 ], xmm4
                            movaps          [edi+80], xmm5
                            movaps          xmm0, [esi+32 ]
                            movaps          xmm1, [esi+80]
                            movaps          xmm4, [esi    ]
                            movaps          xmm5, [esi+48 ]
                            addps           xmm0, xmm2
                            addps           xmm1, xmm3
                            movaps          [esi+32 ], xmm0
                            movaps          [esi+80], xmm1
                            movaps          xmm0, [edi+16 ]
                            movaps          xmm1, [edi+64]
                            mulps           xmm4, xmm2
                            mulps           xmm5, xmm3
                            addps           xmm4, xmm0
                            addps           xmm5, xmm1
                            movaps          xmm0, [edi    ]
                            movaps          xmm1, [edi+48 ]
                            movaps          [edi+16 ], xmm4
                            movaps          [edi+64], xmm5
                            movaps          xmm4, [esi+16 ]
                            movaps          xmm5, [esi+64]
                            mulps           xmm0, xmm2
                            mulps           xmm1, xmm3
                            addps           xmm0, xmm4
                            addps           xmm1, xmm5
                            movaps          [esi+16 ], xmm0
                            movaps          [esi+64], xmm1
                            add             edx, 32
                            add             edi, 96
                            add             esi, 96
                            sub             ecx, 2
                            jnle            loop6
                        loop6_end:
                            add             ecx, 1
                            jz              loop6_end2
                            movaps          xmm2, [edx]
                            movaps          xmm0, xmm2
                            cmpnltps        xmm0, xmm7
                            addps           xmm2, xmm6
                            cvtps2dq        xmm2, xmm2
                            andps           xmm2, xmm0
                            movaps          xmm4, [edi+32]
                            addps           xmm4, xmm2
                            movaps          [edi+32 ], xmm4
                            movaps          xmm0, [esi+32 ]
                            movaps          xmm4, [esi    ]
                            addps           xmm0, xmm2
                            movaps          [esi+32 ], xmm0
                            movaps          xmm0, [edi+16 ]
                            mulps           xmm4, xmm2
                            addps           xmm4, xmm0
                            movaps          xmm0, [edi    ]
                            movaps          [edi+16 ], xmm4
                            movaps          xmm4, [esi+16 ]
                            mulps           xmm0, xmm2
                            addps           xmm0, xmm4
                            movaps          [esi+16 ], xmm0
                        loop6_end2:
                            sub             eax, 1
                            jz              loop7_end
                            
                            mov             ecx, xloopcount
                            mov             edx, diffbuf
                            mov             edi, weightbuf3
                            mov             esi, weightbuf5
                            add             edx, DIFFBUF_BPL
                            jmp             loop7
                         loop7_end:
                            pop             edi
                            pop             esi
                        }
                    }
                }

                src2 = lumasrc + xloopcount * 16 - LUMABUF_BPL - 16;
                for(int i=1; i <= radius; i++)
                {
                    for (int j=-radius; j < 0; j++)
                    {
                        BYTE* src3 = src2 + i * LUMABUF_BPL + j * 16;
                        BYTE* weightbuf2 = weightbuf_rows[i] + (xloopcount + j) * 48;
                        BYTE* weightbuf3 = weightbuf_rows[i+1] + (xloopcount + j) * 48;
                        __asm
                        {
                            push            esi
                            push            edi
                            mov             ecx, radius
                            mov             esi, src3
                            mov             edx, src2
                            mov             edi, diffbuf
                            movaps          xmm2, [esi+LUMABUF_BPL]
                            movaps          xmm3, [esi+LUMABUF_BPL+16]
                            subps           xmm2, [edx+LUMABUF_BPL]
                            subps           xmm3, [edx+LUMABUF_BPL+16]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            movaps          xmm4, [esi+LUMABUF_BPL*2]
                            movaps          xmm5, [esi+LUMABUF_BPL*2+16]
                            subps           xmm4, [edx+LUMABUF_BPL*2]
                            subps           xmm5, [edx+LUMABUF_BPL*2+16]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm2, xmm4
                            addps           xmm3, xmm5
                            movaps          xmm0, [esi]
                            movaps          xmm1, [esi+16]
                            subps           xmm0, [edx]
                            subps           xmm1, [edx+16]
                            mulps           xmm0, xmm0
                            mulps           xmm1, xmm1
                            addps           xmm0, xmm2
                            addps           xmm1, xmm3
                            movaps          xmm6, [esi+LUMABUF_BPL*3]
                            movaps          xmm7, [esi+LUMABUF_BPL*3+16]
                            subps           xmm6, [edx+LUMABUF_BPL*3]
                            subps           xmm7, [edx+LUMABUF_BPL*3+16]
                            mulps           xmm6, xmm6
                            mulps           xmm7, xmm7
                            addps           xmm6, xmm2
                            addps           xmm7, xmm3
                            add             esi, 32
                            add             edx, 32
                        align 16
                        loop8:
                            movaps          xmm2, [esi+LUMABUF_BPL]
                            movaps          xmm3, [esi+LUMABUF_BPL*2]
                            subps           xmm2, [edx+LUMABUF_BPL]
                            subps           xmm3, [edx+LUMABUF_BPL*2]
                            mulps           xmm2, xmm2
                            mulps           xmm3, xmm3
                            movaps          xmm4, [esi]
                            movaps          xmm5, [esi+LUMABUF_BPL*3]
                            subps           xmm4, [edx]
                            subps           xmm5, [edx+LUMABUF_BPL*3]
                            mulps           xmm4, xmm4
                            mulps           xmm5, xmm5
                            addps           xmm2, xmm3
                            movaps          xmm3, xmm0
                            addps           xmm3, xmm1
                            movaps          xmm0, xmm1
                            movaps          xmm1, xmm4
                            addps           xmm1, xmm2
                            movaps          xmm4, xmm6
                            addps           xmm4, xmm7
                            movaps          xmm6, xmm7
                            movaps          xmm7, xmm5
                            addps           xmm7, xmm2
                            addps           xmm3, xmm1
                            addps           xmm4, xmm7
                            mulps           xmm3, f128_fastexp2_a
                            mulps           xmm4, f128_fastexp2_a
                            movaps          [edi], xmm3
                            movaps          [edi+16], xmm4
                            add             esi, 16
                            add             edx, 16
                            add             edi, 32
                            sub             ecx, 1
                            jnz             loop8
                            
                            mov             esi, src2
                            mov             ecx, radius
                            mov             edx, diffbuf
                            add             esi, LUMABUF_BPL+16
                            mov             edi, weightbuf2
                            mov             eax, weightbuf3
                            movaps          xmm6, f128_fastexp2_bmc
                            movaps          xmm7, f128_fastexp2_min
                        align 16
                        loop9:
                            movaps          xmm2, [edx]
                            movaps          xmm3, [edx+16]
                            movaps          xmm0, xmm2
                            movaps          xmm1, xmm3
                            cmpnltps        xmm0, xmm7
                            cmpnltps        xmm1, xmm7
                            addps           xmm2, xmm6
                            addps           xmm3, xmm6
                            cvtps2dq        xmm2, xmm2
                            cvtps2dq        xmm3, xmm3
                            andps           xmm2, xmm0
                            andps           xmm3, xmm1
                            movaps          xmm4, [esi]
                            movaps          xmm5, [esi+LUMABUF_BPL]
                            mulps           xmm4, xmm2
                            mulps           xmm5, xmm3
                            addps           xmm2, [edi+32]
                            addps           xmm3, [eax+32]
                            addps           xmm4, [edi+16]
                            addps           xmm5, [eax+16]
                            movaps          [edi+32], xmm2
                            movaps          [eax+32], xmm3
                            movaps          [edi+16], xmm4
                            movaps          [eax+16], xmm5
                            add             edx, 32
                            add             esi, 16
                            add             edi, 48
                            add             eax, 48
                            sub             ecx, 1
                            jnz             loop9
                            pop             edi
                            pop             esi
                        }
                    }
                }

                weightbuf2 = weightbuf_rows[0];
                weightbuf3 = weightbuf_rows[1];
                __asm
                {
                    push            edi
                    push            esi
                    mov             edx, weightbuf2
                    mov             esi, weightbuf3
                    mov             edi, temp
                    mov             eax, temp_bpl
                    mov             ecx, xloopcount
                align 16
                loop10:
                    rcpps           xmm0, [edx+32]
                    rcpps           xmm1, [edx+80]
                    rcpps           xmm2, [esi+32]
                    rcpps           xmm3, [esi+80]
                    mulps           xmm0, [edx+16]
                    mulps           xmm1, [edx+64]
                    mulps           xmm2, [esi+16]
                    mulps           xmm3, [esi+64]
                    cvtps2dq        xmm0, xmm0
                    cvtps2dq        xmm1, xmm1
                    cvtps2dq        xmm2, xmm2
                    cvtps2dq        xmm3, xmm3
                    packssdw        xmm0, xmm1
                    packssdw        xmm2, xmm3
                    movdqa          [edi], xmm0
                    movdqa          [edi+eax], xmm2
                    add             edx, 96
                    add             esi, 96
                    add             edi, 16
                    sub             ecx, 2
                    jnle            loop10
                    pop             esi
                    pop             edi
                }
                temp += temp_bpl * 2;
                lumasrc += LUMABUF_BPL * 2;
                BYTE* tmp1 = weightbuf_rows[0];
                BYTE* tmp2 = weightbuf_rows[1];
                for(int i=0; i < radius; i++)
                {
                    weightbuf_rows[i] = weightbuf_rows[i+2];
                }
                weightbuf_rows[radius] = tmp1;
                weightbuf_rows[radius+1] = tmp2;
            }
        }
        BYTE* src = _dest + dest2src;
        BYTE* src2 = _temp;
        BYTE* dest = _dest;
        int yloopcount = y_end - y_start;
        int xloopcount = span / 8;
        int xloopcount2 = (width - span * 3 + 7) / 8;
        int srcstep = src_bpl - xloopcount * 48 * 3 - xloopcount2 * 48;
        int tmpstep = temp_bpl - 6;
        __asm
        {
            mov             esi, src
            mov             edx, src2
            mov             edi, dest
        loop_y1:
            mov             ebx, 3
        loop_x2:
            xor             eax, eax
            mov             ecx, xloopcount
        align 16
        loop_x1:
            movdqa          xmm0, [esi]
            movdqa          xmm1, [esi+16]
            movdqa          xmm2, [esi+32]
            pinsrw          xmm0, [edx+eax], 0
            pinsrw          xmm0, [edx+eax+8], 3
            pinsrw          xmm0, [edx+eax+16], 6
            pinsrw          xmm1, [edx+eax+24], 1
            pinsrw          xmm1, [edx+eax+32], 4
            pinsrw          xmm1, [edx+eax+40], 7
            pinsrw          xmm2, [edx+eax+48], 2
            pinsrw          xmm2, [edx+eax+56], 5
            movntdq         [edi], xmm0
            movntdq         [edi+16], xmm1
            movntdq         [edi+32], xmm2
            add             esi, 48
            add             edi, 48
            add             eax, 64
            sub             ecx, 1
            jnz             loop_x1
            add             edx, 2
            sub             ebx, 1
            jnz             loop_x2
            
            xor             eax, eax
            mov             ecx, xloopcount2
        align 16
        loop_x3:
            movdqa          xmm0, [esi]
            movdqa          xmm1, [esi+16]
            movdqa          xmm2, [esi+32]
            pinsrw          xmm0, [edx+eax], 0
            pinsrw          xmm0, [edx+eax+8], 3
            pinsrw          xmm0, [edx+eax+16], 6
            pinsrw          xmm1, [edx+eax+24], 1
            pinsrw          xmm1, [edx+eax+32], 4
            pinsrw          xmm1, [edx+eax+40], 7
            pinsrw          xmm2, [edx+eax+48], 2
            pinsrw          xmm2, [edx+eax+56], 5
            movntdq         [edi], xmm0
            movntdq         [edi+16], xmm1
            movntdq         [edi+32], xmm2
            add             esi, 48
            add             edi, 48
            add             eax, 64
            sub             ecx, 1
            jnz             loop_x3
            
            add             esi, srcstep
            add             edi, srcstep
            add             edx, tmpstep
            sub             yloopcount, 1
            jnz             loop_y1
        }
    }
}

int maxthread;
FILTER_PARAM prm;

static void check_threadcount( int thread_id,int thread_num,void *param1,void *param2 )
{
    if (thread_id == 0)
        *(int*)param1 = thread_num;
}

//---------------------------------------------------------------------
//        tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
    int threadcount = 0;
    fp->exfunc->exec_multi_thread_func(check_threadcount, &threadcount, NULL);
    if (threadcount != maxthread || prm.radius != fp->track[0])
    {
        if (prm.work != NULL)
        {
            _mm_free(prm.work);
            prm.work = NULL;
        }
        maxthread = threadcount;
        prm.radius = fp->track[0];
    }
    
    if (prm.width != fpip->w || prm.height != fpip->h || prm.work == NULL)
    {
        if (prm.work != NULL) _mm_free(prm.work);
        int minsize = 0;
        v_blocksize = 0;
        switch(fp->track[0])
        {
        case 1:
            v_blocksize = 10;
            break;
        case 2:
            minsize = 30;
            break;
        case 3:
            minsize = 54;
            break;
        default:
            minsize = 68;
        }
        if (v_blocksize == 0)
        {
            int mul = 1;
            do
            {
                v_blocksize = (fpip->h + maxthread * mul - 1)/ (maxthread * mul);
                v_blocksize = (v_blocksize+1) &~1;
                mul++;
            }
            while (v_blocksize > minsize);
        }
        
        prm.width = fpip->w;
        prm.height = fpip->h;
        prm.src_bpl = fpip->max_w * (sizeof(short) * 3);
        prm.span = ((prm.width + 31) / 32) * 8;
        prm.temp_bpl = (prm.span * (sizeof(short) * 4)  + 63) &~63;
        prm.pitch = prm.span * (sizeof(short) * 3);
        worksize = (DIFFBUF_BPL*2+WEIGHTBUF_BPL*(MAX_RADIUS+2)+LUMABUF_BPL*(v_blocksize+(MAX_RADIUS+1)*2)) + prm.temp_bpl*v_blocksize;
        prm.work = (BYTE*)_mm_malloc(worksize*maxthread, 128);
        prm.xblocks = (prm.width + H_BLOCKSIZE - 1) / H_BLOCKSIZE;
        prm.maxblock = (prm.height + v_blocksize - 1) / v_blocksize;
        
    }
    prm.ycp_edit = (BYTE*)fpip->ycp_edit;
    prm.ycp_temp = (BYTE*)fpip->ycp_temp;
    prm.atomic_counter = 0;
    
    if (fp->check[0] == 0)
        fp->exfunc->exec_multi_thread_func(nlmeans_luma_filter, (void*)&prm, NULL);
    else
        fp->exfunc->exec_multi_thread_func(nlmeans_luma_filter_gw, (void*)&prm, NULL);
    PIXEL_YC* temp = fpip->ycp_edit;
    fpip->ycp_edit = fpip->ycp_temp;
    fpip->ycp_temp = temp;
    return TRUE;
}

BOOL func_init( FILTER *fp )
{
    f128_gw1 = _mm_set1_ps(0.60653f);
    f128_gw2 = _mm_set1_ps(0.36788f);
    f128_1 =  _mm_set1_ps(1.0f);
    return TRUE;
}

BOOL func_exit( FILTER *fp )
{
    if(prm.work != NULL) _mm_free(prm.work);
    return TRUE;
}

BOOL func_update( FILTER *fp,int status )
{
    double H = (pow((double)fp->track[1] / 100.0, 2) * 40);
    double mH2;
    if(fp->check[0] == 0)
    {
        mH2 = -1.0 / (16.0 * 16.0 * 9.0 * H * H);
    }
    else
    {
        mH2 = -1.0 / (16.0 * 16.0 * 4.89764 * H * H);
    }
    
    f128_fastexp2_a = _mm_set1_ps((float)(mH2 * 0x800000/ M_LN2));
    f128_fastexp2_bmc = _mm_set1_ps((float)((127 << 23) - 8*65536));
    f128_fastexp2_min = _mm_set1_ps((float)(-87.0f * 0x800000 / M_LN2));
    return TRUE;
}

BOOL func_WndProc( HWND hwnd,UINT message,WPARAM wparam,LPARAM lparam,void *editp,FILTER *fp )
{
    if (message == WM_FILTER_CHANGE_ACTIVE)
    {
        if (fp->exfunc->is_filter_active(fp) == FALSE)
        {
            if (prm.work != NULL) _mm_free(prm.work);
            prm.work = NULL;
        }
    }
    return FALSE;
}
